﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace View
{
    /// <summary>
    /// Buttons for the drop down menu buttons when selecting units
    /// </summary>
    class Button
    {
        private ButtonType buttonType;      // holds the button type
        private Vector2 pixelCoordinates;   // holds the coordinates of the menu button in question
        private Texture2D buttonImage;      // stores the texture for the button
        public bool Active { get; set; }   // sets and gets whether button is active

        /**
        Constructor for button
        * @param type Which button type
        * @param coordinates The pixel coordinate of the button
        * @param image The texture for the button
        */
        public Button(ButtonType type, Vector2 coordinates, Texture2D image)
        {
            buttonType = type;
            pixelCoordinates = coordinates;
            buttonImage = image;
            Active = true;
        }

        /**
        Returns the pixel coordinate of the button
        */
        public Vector2 getPixelCoordinates()
        {
            return pixelCoordinates;
        }

        /**
        Returns the button type
        */
        public ButtonType getButtonType()
        {
            return buttonType;
        }

        /**
        Returns the button image
        */
        public Texture2D getImage()
        {
            return buttonImage;
        }

        /**
        Sets the pixelCoordinate
        * @param x The x coordinate of the button
        * @param y the y coordinate of the button
        */
        public void setPixelCoordinates(int x, int y)
        {
            Vector2 coordinates = new Vector2(x, y);
            pixelCoordinates = coordinates;
        }
    }

    /**
    Enumerated list for the possible button types
    */
    enum ButtonType
    {
        Attack,
        AttackConfirm,
        Move,
        Items,
        Wait
    }
}
